#ifndef _COMMAND_HANDLER_H
#define _COMMAND_HANDLER_H

#include "../../stdafx.h"

class Command_Handler : public IO_Module
{
public:
	Command_Handler()
	{
		this->parent = NULL;
		this->moduleId = 0;
		this->currentCommandLength = 0;
		this->displayDistanceSensors = false;
		this->displayPositionTracker = false;
		this->displayBallTracker = false;
		this->displayMouseSensors = false;
		this->ticksPerCmOffset = 0;

		for(uint8 i = 0; i < COMMAND_BUFFER_SIZE; i++)
		{
			buffer[i] = 0;
		}
	}

	Command_Handler(uint32 commandHandlerId)
	{
		this->parent = NULL;
		this->moduleId = commandHandlerId;
		this->currentCommandLength = 0;
		this->displayDistanceSensors = false;
		this->displayPositionTracker = false;
		this->displayBallTracker = false;
		this->displayMouseSensors = false;
		this->ticksPerCmOffset = 0;

		for(uint8 i = 0; i < COMMAND_BUFFER_SIZE; i++)
		{
			buffer[i] = 0;
		}
	}

protected:
	uint8 currentCommandLength;
	uint8 buffer[COMMAND_BUFFER_SIZE];

	void ExecuteCommand();

public:
	void Update();

	void PrintCommand();

	//Command variables
	bool displayDistanceSensors;
	bool displayPositionTracker;
	bool displayBallTracker;
	bool displayMouseSensors;

	float ticksPerCmOffset;
};

#endif
